library librtea;

(**

Ruptor's RTEA pascal implementation by Alexander Myasnikov

Web: www.darksoftware.narod.tu

**)


var
  key: array [0..7] of longint = (0, 0, 0, 0, 0, 0, 0, 0);

  function crypt (var a: longint; var b: longint): longint; export; stdcall;
  var
    r: longint;
  begin

    r := -1;
    repeat
      Inc(r);
      Inc(b, a + ((a shl 6) xor (a shr 8)) + (key[r mod 8] + r));
      Inc(r);
      Inc(a, b + ((b shl 6) xor (b shr 8)) + (key[r mod 8] + r));
    until r = 63;


    Result := 0;
  end;


  function decrypt (var a: longint; var b: longint): longint; export; stdcall;
  var
    r: longint;
  begin

    r := 64;

    repeat

      Dec(r);
      Dec(a, b + ((b shl 6) xor (b shr 8)) + (key[r mod 8] + r));
      Dec(r);
      Dec(b, a + ((a shl 6) xor (a shr 8)) + (key[r mod 8] + r));

    until r = 0;


    Result := 0;
  end;


type
  longintarray = array [0..3] of longint;

type
  plongintarray = ^longintarray;

  function array_crypt (ap: plongintarray; bp: plongintarray): longint; export; stdcall;
  var
    a, b: longint;
  begin
    a := ap[0];
    b := ap[1];

    crypt(a, b);

    bp[0] := a;
    bp[1] := b;


    a := ap[2];
    b := ap[3];

    crypt(a, b);

    bp[2] := a;
    bp[3] := b;


    Result := 0;
  end;


  function array_decrypt (ap: plongintarray; bp: plongintarray): longint; export; stdcall;
  var
    a, b: longint;
  begin
    a := ap[0];
    b := ap[1];

    decrypt(a, b);

    bp[0] := a;
    bp[1] := b;


    a := ap[2];
    b := ap[3];

    decrypt(a, b);

    bp[2] := a;
    bp[3] := b;


    Result := 0;

  end;


  function setup (ap: pointer): longint; export; stdcall;
  begin
    move(ap^, key, 32);
    Result := 0;
  end;

exports
  crypt,
  decrypt,
  setup,
  array_crypt,
  array_decrypt;

end.
